# coding:gbk
# @΢:samequant
# @վ: www.dabange.com 
# @Դصַ: https://dabange.com/download
# @гſγ̡ȡԴд
# @: 2024/3/24

import pandas as pd
import os
import time
from datetime import datetime
# ˻xinyong ͨ˻putong
account_type = 'putong'
# ͨʽ˺šstockĬϡԶ
account_putong = ['ͨʽ˺', 'stock']
# ʽ˺
account_xinyong = ['ʽ˺', 'credit']

def init(C):
    if account_type == 'putong':
        C.accID = account_putong
    elif account_type == 'xinyong':
        C.accID = account_xinyong

    # passorder˺Ϊʱʹһõ˺Ϊµ˺š
    C.set_account(C.accID[0])

    df_m, df_total_asset = get_money_df(C)
    print(df_m)
    print(df_total_asset)

    df_p = get_position_df(C)
    print(df_p)

    df_o = get_order_df(C)
    print(df_o)

def get_money_df(C):
    today_date = time.strftime('%Y-%m-%d', time.localtime())
    total_assets_path = C.account_dir + '/total_assets.csv'
    df_m = pd.DataFrame(columns=['˺', 'ʲ', 'ʲ', 'ֵ', 'ʽ', 'ñ֤'])
    df_asset = pd.DataFrame(columns=['', 'ʲ'])

    if account_type == 'putong':
        # ȡ˻ʲʽdf
        money_info = get_trade_detail_data(C.accID[0], C.accID[1], 'account')
        # print(money_info)
        # print(len(money_info))
        # ʽϢбֻһԪأômoney_infoL[0]
        if len(money_info) == 1:
            df_m.loc[0, '˺'] = money_info[0].m_nBrokerType
            df_m.loc[0, 'ʲ'] = money_info[0].m_dBalance
            df_m.loc[0, 'ʲ'] = money_info[0].m_dAssureAsset
            df_m.loc[0, 'ֵ'] = money_info[0].m_dInstrumentValue
            df_m.loc[0, 'ʽ'] = money_info[0].m_dAvailable
            df_m.loc[0, 'ñ֤'] = 0
            total_assets = df_m.loc[0, 'ʲ']
            if os.path.exists(total_assets_path):
                df_asset = pd.read_csv(total_assets_path)
                if today_date not in df_asset[''].tolist():
                    df_asset = df_asset.append({'': today_date, 'ʲ': total_assets}, ignore_index=True)
                    df_asset = df_asset.tail(30)
                    if (pd.to_datetime(datetime.now()) > pd.to_datetime('15:01')):
                        df_asset.to_csv(total_assets_path, mode='w', index=False)
            else:
                df_asset = df_asset.append({'': today_date, 'ʲ': total_assets}, ignore_index=True)
                df_asset.to_csv(total_assets_path, mode='w', index=False)

    if account_type == 'xinyong':
        money_info = get_trade_detail_data(C.accID[0], C.accID[1], 'account')
        if len(money_info) == 1:
            # ʽϢбֻһԪأômoney_infoL[0]
            df_m.loc[0, '˺'] = money_info[0].m_nBrokerType
            df_m.loc[0, 'ʲ'] = money_info[0].m_dBalance
            df_m.loc[0, 'ʲ'] = money_info[0].m_dAssureAsset
            df_m.loc[0, 'ֵ'] = money_info[0].m_dInstrumentValue
            df_m.loc[0, 'ʽ'] = money_info[0].m_dAvailable
            df_m.loc[0, 'ñ֤'] = money_info[0].m_dEnableBailBalance

            total_assets = df_m.loc[0, 'ʲ']
            if os.path.exists(total_assets_path):
                df_asset = pd.read_csv(total_assets_path)
                if today_date not in df_asset[''].tolist():
                    df_asset = df_asset.append({'': today_date, 'ʲ': total_assets}, ignore_index=True)
                    df_asset = df_asset.tail(30)
                    if (pd.to_datetime(datetime.now()) > pd.to_datetime('15:01')):
                        df_asset.to_csv(total_assets_path, mode='w', index=False)
            else:
                df_asset = df_asset.append({'': today_date, 'ʲ': total_assets}, ignore_index=True)
                df_asset.to_csv(total_assets_path, mode='w', index=False)

    return df_m, df_asset


def get_position_df(C):
    today_date = time.strftime('%Y-%m-%d', time.localtime())
    # ȡ˻ֲdf
    position_info = get_trade_detail_data(C.accID[0], C.accID[1], 'position')

    # print(position_info, type(position_info))
    # print('鿴Щֶ:', dir(position_info[0]))

    def position_to_dict(pos):
        return {
            'Ʊ': pos.m_strInstrumentID + '.' + pos.m_strExchangeID,
            'ֲ': pos.m_nVolume,
            '': pos.m_nCanUseVolume,
            'ֲֵ': pos.m_dMarketValue,
            'ֲֳɱ': pos.m_dPositionCost,
            'ֲӯ': pos.m_dPositionProfit,
            'ӯ': pos.m_dFloatProfit,
            'ɱ': pos.m_dOpenPrice
        }

    if len(position_info) > 0:
        df_pos = pd.DataFrame(list(map(position_to_dict, position_info)))
        df_pos = df_pos[['Ʊ', 'ֲ', '', 'ֲֵ', 'ֲӯ', 'ӯ', 'ֲֳɱ', 'ɱ']]
        df_pos['ɱ'] = df_pos['ɱ'].round(2)
        always_pos_path = C.account_dir + '/position.csv'
        if os.path.exists(always_pos_path):
            df_pos_always = pd.read_csv(always_pos_path)
            df_pos_merge = pd.merge(left=df_pos, right=df_pos_always, on=['Ʊ'], how='left')
            df_pos_merge = df_pos_merge[df_pos_merge['ֲ'] > 0]
            condition = df_pos_merge['ֲ_'] > 0
            df_pos_merge.loc[condition, ''] = df_pos_merge['_']
            # print(df_pos_merge)
            condition_today = (df_pos_merge[''].isna() == True) & (df_pos_merge['ֲ'] > 0)
            df_pos_merge.loc[condition_today, ''] = today_date

            # print(df_pos_merge)
            for i in df_pos_merge.index:
                if df_pos_merge.loc[i, '']:
                    if today_date in trade_canlerdar_lst:
                        df_pos_merge.loc[i, ''] = trade_canlerdar_lst.index(today_date) - trade_canlerdar_lst.index(
                            df_pos_merge.loc[i, '']) + 1
                    else:
                        print('ǽգ')
                else:
                    df_pos_merge.loc[i, ''] = 1

            df_pos_merge = df_pos_merge[['Ʊ', 'ֲ', '', 'ֲӯ', 'ɱ', '', '']]
            df_pos_merge.reset_index(drop=True, inplace=True)
            # if (pd.to_datetime(datetime.now()) > pd.to_datetime('15:01')):
            #    update_position_closed(C)
            return df_pos_merge

        else:
            condition_today = (df_pos['ֲ'] > 0) & (df_pos[''] == 0)
            df_pos.loc[condition_today, ''] = today_date
            df_pos.loc[condition_today, ''] = 1
            df_pos = df_pos[['Ʊ', 'ֲ', '', 'ֲӯ', 'ɱ', '', '']]

            df_pos_c = df_pos.copy()
            df_pos_c = df_pos_c[['Ʊ', 'ֲ', '', 'ɱ', '', '']]
            df_pos_c.rename(columns={'ֲ': 'ֲ_', '': '_', 'ɱ': 'ɱ_', '': '_'}, inplace=True)
            df_pos_c.to_csv(always_pos_path, mode='w', index=False)

            return df_pos
    else:
        return pd.DataFrame(columns=['Ʊ', 'ֲ', '', 'ֲӯ', 'ɱ', '', ''])


def get_deal_df(C):
    # ȡ˻ֲdf
    deal_info = get_trade_detail_data(C.accID[0], C.accID[1], 'deal')

    # print(deal_info, type(deal_info))

    def deal_to_dict(deal):
        return {
            'ʽ˺': deal.m_strAccountID,
            'Ʊ': deal.m_strInstrumentID + '.' + deal.m_strExchangeID,
            'ɽ': deal.m_strTradeID,
            'ίк': deal.m_strOrderSysID,
            '': deal.m_nDirection,
            '': deal.m_strOptName,
            'ɽ': deal.m_dPrice,
            'ɽ': deal.m_nVolume,
            'ɽ': deal.m_strTradeDate,
            'ɽʱ': deal.m_strTradeTime,
            'ɽ': deal.m_dTradeAmount,
        }

    if len(deal_info) > 0:
        # print('鿴Щֶ:', dir(deal_info[0]))
        df_deal = pd.DataFrame(list(map(deal_to_dict, deal_info)))
        if not df_deal.empty:
            df_deal = df_deal[['Ʊ', 'ɽ', 'ίк', '', '', 'ɽ', 'ɽ', 'ɽ', 'ɽʱ', 'ɽ']]
            # print(df_deal)
            return df_deal
    else:
        return pd.DataFrame(columns=['Ʊ', 'ɽ', 'ίк', '', '', 'ɽ', 'ɽ', 'ɽ', 'ɽʱ', 'ɽ'])


def get_order_df(C):
    # ȡίϢ
    order_infoL = get_trade_detail_data(C.accID[0], C.accID[1], 'order')
    # print(len(order_infoL), type(order_infoL))
    df_order = pd.DataFrame(columns=['ʽ˺', 'Ʊ', 'ίк', 'ίʱ', 'ί', 'ɽ', '', 'ί״̬'])

    def order_to_dict(order):
        return {
            'ʽ˺': order.m_strAccountID,
            'Ʊ': order.m_strInstrumentID + '.' + order.m_strExchangeID,
            'ίк': order.m_strOrderSysID,
            'ίʱ': order.m_strInsertTime,
            'ί': order.m_nVolumeTotalOriginal,
            'ɽ': order.m_nVolumeTraded,
            '': order.m_strOptName,
            'ί״̬': order.m_nOrderStatus
        }

    if len(order_infoL) > 0:
        df_order = pd.DataFrame(list(map(order_to_dict, order_infoL)))
        df_order = df_order[['ʽ˺', 'Ʊ', 'ίк', 'ίʱ', 'ί', 'ɽ', '', 'ί״̬']]
        df_order['ίʱ'] = df_order['ίʱ'].str[0:2] + ':' + df_order['ίʱ'].str[2:4] + ':' + df_order['ίʱ'].str[4:6]
    # print(df_order)

    return df_order

